VERSION 5.00
Begin VB.Form frmPathElipsis 
   AutoRedraw      =   -1  'True
   Caption         =   "Draw Path Elipsis"
   ClientHeight    =   1905
   ClientLeft      =   3210
   ClientTop       =   1530
   ClientWidth     =   3585
   Icon            =   "frmPathElipsis.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   127
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   239
   Begin VB.CommandButton Command1 
      Caption         =   "Select Path"
      Height          =   360
      Left            =   960
      TabIndex        =   1
      Top             =   1260
      Width           =   1515
   End
   Begin VB.Label Label2 
      Caption         =   "See how easy it is to add elipsis to the middle of a string to make it fit within a given area."
      Height          =   540
      Left            =   105
      TabIndex        =   2
      Top             =   60
      Width           =   3285
   End
   Begin VB.Label Label1 
      Height          =   240
      Left            =   450
      TabIndex        =   0
      Top             =   765
      Width           =   2655
   End
   Begin VB.Label Label3 
      BorderStyle     =   1  'Fixed Single
      Height          =   330
      Left            =   405
      TabIndex        =   3
      Top             =   720
      Width           =   2760
   End
End
Attribute VB_Name = "frmPathElipsis"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to use the DrawText API function to
  ' shorten a string and add elipsis in the removed section.
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.

  Private Const vbZLString As String = ""
  
  Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type

  ' DrawText() Format Flags
  Private Const DT_TOP As Long = &H0&
  Private Const DT_LEFT As Long = &H0&
  Private Const DT_CENTER As Long = &H1&
  Private Const DT_RIGHT As Long = &H2&
  Private Const DT_VCENTER As Long = &H4&
  Private Const DT_BOTTOM As Long = &H8&
  Private Const DT_WORDBREAK As Long = &H10&
  Private Const DT_SINGLELINE As Long = &H20&
  Private Const DT_EXPANDTABS As Long = &H40&
  Private Const DT_TABSTOP As Long = &H80&
  Private Const DT_NOCLIP As Long = &H100&
  Private Const DT_EXTERNALLEADING As Long = &H200&
  Private Const DT_CALCRECT As Long = &H400&
  Private Const DT_NOPREFIX As Long = &H800&
  Private Const DT_INTERNAL As Long = &H1000&
  Private Const DT_EDITCONTROL As Long = &H2000&
  Private Const DT_END_ELLIPSIS As Long = &H8000&
  Private Const DT_MODIFYSTRING As Long = &H10000
  Private Const DT_PATH_ELLIPSIS As Long = &H4000&
  Private Const DT_RTLREADING As Long = &H20000
  Private Const DT_WORD_ELLIPSIS As Long = &H40000
  
  Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC&, ByVal lpStr$, ByVal nCount&, lpRect As RECT, ByVal wFormat&) As Long

Private Sub Command1_Click()

  Dim sPath$, rc As RECT
  Dim oGetPath As cGetFileName
  
  Set oGetPath = New cGetFileName
  
  ' get the path we want to display
  sPath = oGetPath.GetOpenName(Me.hWnd, App.Path)
  
  Set oGetPath = Nothing
  
  If sPath <> vbZLString Then
    ' fill in the length and height of the area we want to display in
    With rc
      .Right = ScaleX(Label1.Width, Me.ScaleMode, vbPixels)
      .Bottom = ScaleY(Label1.Height, Me.ScaleMode, vbPixels)
    End With
    
    ' make sure the fonts are the same
    Me.Font = Label1.Font
    
    ' let drawtext do all of the work for us!
    Call DrawText(Me.hDC, sPath, Len(sPath), rc, DT_CALCRECT Or DT_MODIFYSTRING Or DT_PATH_ELLIPSIS Or DT_LEFT Or DT_SINGLELINE Or DT_VCENTER)
  
    ' assign the result
    Label1.Caption = StripNulls(sPath)
  End If
  
End Sub

Public Function StripNulls(ByVal sText As String) As String
  ' strips any nulls from the end of a string
  Dim nPosition&
  
  StripNulls = sText
  
  nPosition = InStr(sText, vbNullChar)
  If nPosition Then StripNulls = Left$(sText, nPosition - 1)
  If Len(sText) Then If Left$(sText, 1) = vbNullChar Then StripNulls = vbZLString
End Function

